#include "TThread.h"
#include "ArgoFrame.h"

const int NSCAL = 7;
const int NClusAcq = (NSCAL * 20);
const int Clus[NClusAcq]={151,152,239,122,121,124,123,240,135,136,
			  149,150,133,134,147,148,120,119,241,242,
			  80,93,94,107,108,35,36,49,50,63,
			  64,77,78,91,92,105,106,137,138,243,
			  39,40,53,54,67,68,81,82,95,96,
			  109,110,37,38,51,52,65,66,79,244,
			  89,76,75,62,61,48,47,34,33,104,
			  103,90,31,32,45,46,59,60,87,245,
			  202,201,188,187,174,173,160,159,146,145,
			  132,131,204,203,190,164,163,206,205,246,
			  192,191,178,177,165,166,189,176,175,193,
			  180,179,208,207,194,161,118,117,162,247,
			  88,101,102,73,74,144,157,158,129,130,
			  143,171,172,185,186,199,200,115,116,248};
const int Clus_g[NClusAcq]={31,32,33,34,35,36,37,38,39,40,
			    45,46,47,48,49,50,51,52,53,54,
			    59,60,61,62,63,64,65,66,67,68,
			    73,74,75,76,77,78,79,80,81,82,
			    87,88,89,90,91,92,93,94,95,96,
			    101,102,103,104,105,106,107,108,109,110,
			    115,116,117,118,119,120,121,122,123,124,
			    129,130,131,132,133,134,135,136,137,138,
			    143,144,145,146,147,148,149,150,151,152,
			    157,158,159,160,161,162,163,164,165,166,
			    171,172,173,174,175,176,177,178,179,180,
			    185,186,187,188,189,190,191,192,193,194,
			    199,200,201,202,203,204,205,206,207,208,
			    239,240,241,242,243,244,245,246,247,248};

		    
int jc[NClusAcq];
		
const int wx=1;
const int wy=1;
const int lc=16;
const int wc=8;
const char *buff;

int YER;
int MON;
int DY;
static int _day;
int HR;
static int _hour;
int MT;
static int _min;

int kount_inf=0;
int kount_sup=7250;
int Nkount = (kount_sup - kount_inf)/120;
int k;
int iread;
int SleepTime=10000;
int nhourmin = 0;
int nhourmax = 24;
int yr;
int mth;
int dy;
int hr;
int fom;
int kfile=0;
int meas_inf;
int meas_sup;
int meas;
int mred[NClusAcq];
int npag = 11;
int nclupag = 12;
int idraw[11][4];
int jpos = 0;
static int BID;

double average[4]={20000.,1000.,150.,60.};
double scal1[59][NClusAcq];
double scal2[59][NClusAcq];
double scal3[59][NClusAcq];
double scal4[59][NClusAcq];
double avscal1[59][NClusAcq];
double avscal2[59][NClusAcq];
double avscal3[59][NClusAcq];
double avscal4[59][NClusAcq];
double HRSCAL1[59][NClusAcq];
//double HRSCAL2[59][NClusAcq];
//double HRSCAL3[59][NClusAcq];
//double HRSCAL4[59][NClusAcq];
double DYSCAL1[59*24][NClusAcq];
double refscal1[NClusAcq];
//double refscal2[NClusAcq];
//double refscal3[NClusAcq];
//double refscal4[NClusAcq];
double scal1_inf[NClusAcq];
double scal1_sup[NClusAcq];
double scal1_infmed[NClusAcq];
double scal1_supmed[NClusAcq];
double J_inf;
double J_sup;
double Jint[59];
double T0;
double Kount_inf=0;
double Kount_sup;
double SCALINF[NClusAcq];
double SCALSUP[NClusAcq];

char ThName[100];
char tmp[100];
char taxis[100];
char listnam[100]; 
char namgr[100];
char namth[100];
char titth[100];
char nam1[100];
char tit1[100];
char nam2[100];
char cluster[100];
char outfile[150];
char flnm[100];
char flnm1[100];
char flnm2[100];
char kntb[100];
char nam_scal[100];
char tit_scal[100];
char dayy[100];
char dayy_h[100];
char rawfile[150];
char rawfile_h[150];
char hmdir[150];
char ref[150];
char ref2[150];
char cluname[100];

string DIR;
string HMDIR;

bool  keep_going,stay_quiet,loop_ev;


TH1F       *th1[NClusAcq];
TH1F       *THAV1[NClusAcq];
TH1F       *th2[NClusAcq];
TH1F       *th3[NClusAcq];
TH1F       *th4[NClusAcq];
TH2F       *htmp1[NClusAcq];
TH1F       *ths;
  
TLine      *ln[NClusAcq];
TLine      *tln;

TPaveText  *pt1[NClusAcq];
TPaveText  *tl1[NClusAcq];

TCanvas    *fC1;
TCanvas    *fCN;

ArgoFrame *thrargo;

TFile 	   *froot;



// ==============  SWAP functions used to read the data ==============

unsigned short swap16(unsigned short a)   { return ( ((a&0xFF00)>>8) | ((a&0x00FF)<< 8)); }
unsigned int swap32(unsigned int a)       { return ( ((a&0xFF000000)>>24) | ((a&0x00FF0000)>> 8) | ((a&0x0000FF00)<< 8) | ((a&0x000000FF)<<24) ); } 



// ==============  from Gregorian to Julian day ==============  

double G2J(int Y, int M, int D, int h, int m, double s) {
  if (M<3) { M+=12; Y--; }   
  double J = (int) (365.25*(Y+4716)) + (int) (30.6001*(M+1)) + D 
    + (double)h/24 + (double)m/1440 + s/86400 + 2 - Y/100 + Y/400 - 1524.5;
  J -= 2450000;
  return J;
};



// ========================= GRAPHIC ===========================


ArgoFrame::ArgoFrame(const TGWindow *p, UInt_t w, UInt_t h)  {

  mThreadrun = kFALSE;
  fTh1 = NULL;
  fdata = NULL;
  fActiveHistos = NULL;
  hID = NULL;
  tln = NULL;
  for(int j=0;j<NClusAcq;j++){
    tl1[j] = NULL;
    ln[j] = NULL;
    pt1[j] = NULL;
  }
  
  sch = 0;

  _min = -1;  // hour of file currently read 
  _hour = -1;
  _day = -1;

  // ========================= Main frame ===========================
 
  fMain = new TGMainFrame(p,w,h);

  filebuffer = new TGTextView(fMain,200,25,kSunkenFrame | kDoubleBorder);
  fMain->AddFrame(filebuffer,new TGLayoutHints(kLHintsCenterX,1,1,1,1));

   // ======================= Canvas widgets =========================

   fEcanvas = new TRootEmbeddedCanvas("Ecanvas",fMain,1000,420);
   fMain->AddFrame(fEcanvas, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY,
					      5,5,1,1));
  
   fC1 = fEcanvas->GetCanvas();
   fC1->Divide(4,3);
  // ================= Horizontal frame with buttons =================

  hframe = new TGHorizontalFrame(fMain,600,10);

  kountbuffer = new TGTextView(hframe,80,25,kSunkenFrame | kDoubleBorder);
  hframe->AddFrame(kountbuffer);

  draw = new TGTextButton(hframe,"&Draw");
  draw->Connect("Clicked()","ArgoFrame",this,"DoDraw()");
  hframe->AddFrame(draw, new TGLayoutHints(kLHintsCenterX,5,5,2,1));

  exit = new TGTextButton(hframe,"&Exit");
  exit->Connect("Clicked()","ArgoFrame",this,"CloseMainFrame()");
  hframe->AddFrame(exit, new TGLayoutHints(kLHintsCenterX,5,5,2,1));
   
  forw = new TGTextButton(hframe,"&>>");
  forw->Connect("Clicked()","ArgoFrame",this,"Forward()");
  hframe->AddFrame(forw, new TGLayoutHints(kLHintsRight,5,5,2,1));

  back = new TGTextButton(hframe,"&<<");
  back->Connect("Clicked()","ArgoFrame",this,"Backward()");
  hframe->AddFrame(back, new TGLayoutHints(kLHintsRight,5,5,2,1));

  fMain->AddFrame(hframe, new TGLayoutHints(kLHintsCenterX,10,10,1,1));

  // ======================== ListBox ==============================

    
  fBox = new TGGroupFrame(fMain,"Scaler",kVerticalFrame);

  Llist = new TGLayoutHints(kLHintsTop | kLHintsLeft,10,10,10,10);
  flist = new TGListBox(fBox,90);

  for(int i=0;i<4;i++) {
    sprintf(tmp,"Scaler%i",i+1);
    flist->AddEntry(tmp,i);
  };
   
  flist->Resize(150,80);
  fBox->AddFrame(flist,Llist);  
  fMain->AddFrame(fBox, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 5, 5,-140,5));

  const TGFont *fontf = gClient->GetFont("-adobe-helvetica-bold-r-*-*-14-*-*-*-*-*-iso8859-1");
  FontStruct_t filefont = fontf->GetFontStruct();
  filebuffer->SetFont(filefont);
  const TGFont *fontk = gClient->GetFont("-adobe-helvetica-medium-r-*-*-14-*-*-*-*-*-iso8859-1");
  FontStruct_t kountfont = fontk->GetFontStruct(); 
  kountbuffer->SetFont(kountfont);

  // ====================== Argo Panel ============================

  fPanel = new TGGroupFrame(fMain, "ARGO", kVerticalFrame);

  h1frame = new TGHorizontalFrame(fPanel,100,50);
  h2frame = new TGHorizontalFrame(fPanel,100,50);
  h3frame = new TGHorizontalFrame(fPanel,100,50);
  h4frame = new TGHorizontalFrame(fPanel,100,50);
  h5frame = new TGHorizontalFrame(fPanel,100,50);
  h6frame = new TGHorizontalFrame(fPanel,100,50);
  h7frame = new TGHorizontalFrame(fPanel,100,50);
  h8frame = new TGHorizontalFrame(fPanel,100,50);
  h9frame = new TGHorizontalFrame(fPanel,100,50);
  h10frame = new TGHorizontalFrame(fPanel,100,50);
  h11frame = new TGHorizontalFrame(fPanel,100,50);
  h12frame = new TGHorizontalFrame(fPanel,100,50);
  h13frame = new TGHorizontalFrame(fPanel,100,50);
  h14frame = new TGHorizontalFrame(fPanel,100,50);
  h15frame = new TGHorizontalFrame(fPanel,100,50);
  h16frame = new TGHorizontalFrame(fPanel,100,1000);
  h17frame = new TGHorizontalFrame(fPanel,100,1000); 
   
  singolo((lc+(int)(lc/wc))*wx,wy,2,h1frame);
  singolo((lc+(int)(lc/wc))*wx,wy,4,h1frame);
  singolo((lc+(int)(lc/wc))*wx,wy,6,h1frame);
  singolo(((int)(lc/wc)*lc+2*(int)(lc/wc))*wx,wy,9,h1frame);
  singolo((lc+(int)(lc/wc))*wx,wy,11,h1frame);
  singolo((lc+(int)(lc/wc))*wx,wy,13,h1frame);

  singolo(wx,wy*lc,29,h2frame);
  riga1(wx,wy,31,h2frame);
  singolo(lc*wx,wy,42,h2frame);

  singolo(((int)(lc/wc)*lc+(int)(lc/wc))*wx,wy,45,h3frame);
  riga2(wx,wy,46,h3frame);

  singolo(wx,wy*lc,57,h4frame);
  riga1(wx,wy,59,h4frame);
  singolo(lc*wx,wy,70,h4frame);

  singolo(((int)(lc/wc)*lc+(int)(lc/wc))*wx,wy,73,h5frame);
  riga2(wx,wy,74,h5frame);

  singolo(((int)(lc/wc)*lc+(int)(lc/wc))*wx,wy,87,h6frame);
  riga2(wx,wy,88,h6frame);

  singolo(wx,wy*lc,99,h7frame);  
  riga1(wx,wy,101,h7frame);
  singolo(lc*wx,wy,112,h7frame);

  singolo(((int)(lc/wc)*lc+(int)(lc/wc))*wx,wy,115,h8frame);
  riga2(wx,wy,116,h8frame);

  singolo(wx,wy*lc,127,h9frame);  
  riga1(wx,wy,129,h9frame);
  singolo(lc*wx,wy,140,h9frame);

  singolo(((int)(lc/wc)*lc+(int)(lc/wc))*wx,wy,143,h10frame); 
  riga2(wx,wy,144,h10frame);

  singolo(((int)(lc/wc)*lc+(int)(lc/wc))*wx,wy,157,h11frame); 
  riga2(wx,wy,158,h11frame);

  singolo(wx,wy*lc,169,h12frame);  
  riga1(wx,wy,171,h12frame);
  singolo(lc*wx,wy,182,h12frame);

  singolo(((int)(lc/wc)*lc+(int)(lc/wc))*wx,wy,185,h13frame); 
  riga2(wx,wy,186,h13frame);

  singolo(wx,wy*lc,197,h14frame);  
  riga1(wx,wy,199,h14frame);
  singolo(lc*wx,wy,210,h14frame);

  singolo((lc+(int)(lc/wc))*wx,wy,226,h15frame);
  singolo((lc+(int)(lc/wc))*wx,wy,228,h15frame);
  singolo((lc+(int)(lc/wc))*wx,wy,230,h15frame);
  singolo(((int)(lc/wc)*lc+2*(int)(lc/wc))*wx,wy,233,h15frame);
  singolo((lc+(int)(lc/wc))*wx,wy,235,h15frame);
  singolo((lc+(int)(lc/wc))*wx,wy,237,h15frame);

  fPanel->AddFrame(h1frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h16frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,5));
  fPanel->AddFrame(h2frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h3frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h4frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h5frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h6frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h7frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h8frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h9frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h10frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h11frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h12frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h13frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h14frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));
  fPanel->AddFrame(h17frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,5));
  fPanel->AddFrame(h15frame, new TGLayoutHints(kLHintsTop | kLHintsLeft,1,1,1,1));

  fMain->AddFrame(fPanel, new TGLayoutHints(kLHintsBottom | kLHintsRight,5,5,5,5));
 
  // ==============================================================

  fMain->SetWindowName("Argo Single Online Monitor");
  fMain->MapSubwindows();
  fMain->Resize(fMain->GetDefaultSize());
  fMain->MapWindow();
    
};



void ArgoFrame::riga1(int x, int y, int k,TGHorizontalFrame *horframe) {    
  
  for (int n=k;n<k+10;n++) {
    char nt[4];   sprintf(nt,"%3d",n);
    fButtonclu[n] = new TGButton(horframe,n);
    fButtonclu[n]->SetToolTipText(nt,250);
    fButtonclu[n]->Resize(lc,wc);
    horframe->AddFrame(fButtonclu[n], new TGLayoutHints(kLHintsTop | kLHintsLeft,x,y,1,1));
  }
}

void ArgoFrame::riga2(int x, int y, int k,TGHorizontalFrame *horframe) {    
  
  for (int n=k;n<k+9;n++) {  
    char nt[4];   sprintf(nt,"%3d",n);
    fButtonclu[n] = new TGButton(horframe,n);
    fButtonclu[n]->SetToolTipText(nt,250);
    fButtonclu[n]->Resize(lc,wc);
    horframe->AddFrame(fButtonclu[n], new TGLayoutHints(kLHintsTop | kLHintsLeft,x,y,1,1));
  }
}

void ArgoFrame::singolo(int x, int y, int k, TGHorizontalFrame *horframe) { 
  char nt[4];   sprintf(nt,"%3d",k);
  fButtonclu[k] = new TGButton(horframe,k);
  fButtonclu[k]->SetToolTipText(nt,250);
  fButtonclu[k]->Resize(lc,wc);
  horframe->AddFrame(fButtonclu[k], new TGLayoutHints(kLHintsTop | kLHintsLeft,x,y,1,1));
 }


ArgoFrame::~ArgoFrame()
{
  delete Llist; 
  delete flist;
  delete h1frame; delete h2frame; delete h3frame; delete h4frame; delete h5frame; delete h6frame;
  delete h7frame; delete h8frame; delete h9frame; delete h10frame; delete h11frame; delete h12frame;
  delete h13frame; delete h14frame; delete h15frame; delete h16frame; delete h17frame; 
  delete back; delete forw; delete exit; delete draw; delete kountbuffer; 
  delete fBox;
  delete fPanel;
  delete hframe;
  delete fEcanvas;
  delete filebuffer;
  fMain->Cleanup();
  delete fMain;
};


void ArgoFrame::WinFrame(const TGWindow *p, UInt_t w, UInt_t h)  {

  sprintf(cluname,"CLUSTER %i",BID);

  fMainWin = new TGTransientFrame(p,fMain,w,h);

  fEcanWin = new TRootEmbeddedCanvas("canvas",fMainWin,600,300);
  fMainWin->AddFrame(fEcanWin, new TGLayoutHints(kLHintsExpandX | 
						 kLHintsExpandY,5,5,10,1));
  fCN = fEcanWin->GetCanvas();

  hwinframe = new TGHorizontalFrame(fMainWin,300,100);

  win = new TGTextButton(hwinframe,"&Close");
  win->Connect("Clicked()","ArgoFrame",this,"CloseWin()");
  hwinframe->AddFrame(win, new TGLayoutHints(kLHintsCenterX,10,10,2,1));

  ULong_t color;
  gClient->GetColorByName("light goldenrod",color);
  win->ChangeBackground(color);
  

  fMainWin->AddFrame(hwinframe, new TGLayoutHints(kLHintsCenterX,5,5,5,5));
  fMainWin->SetWindowName(cluname);
  fMainWin->MapSubwindows();
  fMainWin->Resize(fMainWin->GetDefaultSize());
  fMainWin->MapWindow();



};



// ========================== OpenFile =============================



void ArgoFrame::Histo(int Reset) {

  // histogramms booking
  if( Reset==0 ) {
    for (int j=0;j<NClusAcq;j++){
      sprintf(tit_scal,"Cluster %03d",Clus[j]);
      sprintf(nam_scal,"AveScaler1vsTime_%03d",Clus[j]);
      THAV1[j] = new TH1F(nam_scal,tit_scal,24*59*10,0,24*59);
      sprintf(tit_scal,"Cluster %03d",Clus[j]);
      sprintf(nam_scal,"Scaler1vsTime_%03d",Clus[j]);
      th1[j] = new TH1F(nam_scal,tit_scal,Nkount,kount_inf,kount_sup);
      sprintf(tit_scal,"Cluster %03d",Clus[j]);
      sprintf(nam_scal,"Scaler2vsTime_%03d",Clus[j]);
      th2[j] = new TH1F(nam_scal,tit_scal,Nkount,kount_inf,kount_sup);
      sprintf(tit_scal,"Cluster %03d",Clus[j]);
      sprintf(nam_scal,"Scaler3vsTime_%03d",Clus[j]);
      th3[j] = new TH1F(nam_scal,tit_scal,Nkount,kount_inf,kount_sup);
      sprintf(tit_scal,"Cluster %03d",Clus[j]);
      sprintf(nam_scal,"Scaler4vsTime_%03d",Clus[j]);
      th4[j] = new TH1F(nam_scal,tit_scal,Nkount,kount_inf,kount_sup);
    }
  } else {            
    // reset histograms (change file)
    cout << "Reset Histos " << endl << endl;
    for (int j=0;j<NClusAcq;j++){
      th1[j]->Reset("ICE");
      th2[j]->Reset("ICE");
      th3[j]->Reset("ICE");
      th4[j]->Reset("ICE");
    };
   
  };
  return;
}


Bool_t ArgoFrame::GetThreadRun() {
  return mThreadrun;
}

void ArgoFrame::Thread1(void* arg){
  // thread function which calls function ReadData() with loop on files 
  TThread::SetCancelOn();
  TThread::SetCancelDeferred();
  thrargo = (ArgoFrame*) arg;
  Int_t meid=TThread::SelfId(); // get pthread id
  cout << "Thread 1, id:" << meid << " is running..\n" << endl;
  while(thrargo->GetThreadRun()){
    	// loop keeps thread alive...
	TThread::CancelPoint();
	thrargo->ReadData(); 
  };
};


void ArgoFrame::ReadData() {

  int nMagicNo;
  int nMask;
  int OPF = 0;
  ofstream outave;
  ifstream inave;

  for(int s=0;s<npag;s++) for(int t=0;t<4;t++) idraw[s][t]=0;
  for(int s=0;s<24;s++) for(int t=0; t<NClusAcq; t++) DYSCAL1[s][t]=0;

  struct tm *ptm; 
  bool loopfile = true;

  while(loopfile) {

    skip_point:

    // Read Time from System
    time_t atime = time(0x0);
    ptm = localtime(&atime);
    YER = ptm->tm_year +1900;
    MON = ptm->tm_mon +1;
    DY = ptm->tm_mday;
    HR = ptm->tm_hour-1;
    //MT = ptm->tm_min-0;

    // ==================  Open File ==================


        if(HR != _hour){
          _kount =0;
          OPF = 1;
          keep_going = true;
          _hour=HR;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) scal1[s][t]=0;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) scal2[s][t]=0;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) scal3[s][t]=0;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) scal4[s][t]=0;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) avscal1[s][t]=-20;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) avscal2[s][t]=-20;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) avscal3[s][t]=-20;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) avscal4[s][t]=-20;
          for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) HRSCAL1[s][t]=0;
          for(int t=0; t<NClusAcq; t++) refscal1[t]=0;
          for(int t=0; t<NClusAcq; t++) scal1_inf[t]=0;
          for(int t=0; t<NClusAcq; t++) scal1_sup[t]=0;
          for(int t=0; t<NClusAcq; t++) mred[t]=0;
          for(int s=0;s<59;s++) Jint[s]=0;

          if(fdata==NULL){
        	Histo(0); 
	
	        sprintf(flnm1,"             grb%02d%02d%02d.%02d",(YER-2000),MON,DY,_hour);
	        filebuffer->LoadBuffer(flnm1);

        	sprintf(dayy,"%s/grb%02d%02d%02d.%02d",DIR.c_str(),(YER-2000),MON,DY,_hour);
        	sprintf(rawfile,"%s",dayy);

        	fdata = fopen(rawfile,"r");
        	cout << "kfile = " << kfile << endl;
        	cout << "Open file : " << rawfile << endl;
        	if(fdata == NULL) {printf("File : %s not found\n",rawfile); return;};
        	OPF = 0;
          }else{

	    cout << "_hour = " << _hour << endl;
	    cout << "HR = " << HR << endl;
        	int chiusura = fclose(fdata);  
        	cout << "fclose = " << chiusura << endl;
        	Histo(1);
        	sprintf(dayy,"%s/grb%02d%02d%02d.%02d",DIR.c_str(),(YER-2000),MON,DY,_hour);
        	sprintf(rawfile,"%s",dayy);
        	fdata = fopen(rawfile,"r");
        	kfile++;
        	cout << "kfile = " << kfile << endl;
        	cout << "Open file : " << rawfile << endl;
        	if(fdata == NULL) {printf("File : %s not found\n",rawfile); return;};
        	OPF = 0;


	       sprintf(flnm2,"             grb%02d%02d%02d.%02d",(YER-2000),MON,DY,_hour);
	       filebuffer->LoadBuffer(flnm2);

          };
        }else{goto skip_point;};

  
    //  ====================== MagicNo ==============================
 
    iread = fread(&nMagicNo, sizeof(int), 1, fdata);

    if(iread==0){
      stay_quiet = true;
      while(stay_quiet) { gSystem->Sleep(SleepTime);
	iread = fread(&nMagicNo, sizeof(int), 1, fdata);
	if(iread!=0) {stay_quiet = false;}
      };
    };


    //  ====================== nMask ===============================

    iread = fread(&nMask, sizeof(int), 1, fdata);

    if(iread==0){
      stay_quiet = true;
      while(stay_quiet) { gSystem->Sleep(SleepTime);
	iread = fread(&nMask, sizeof(int), 1, fdata);
	if(iread!=0) {stay_quiet = false;}
      };
    };
  
 
    // ======================= Loop on the events ======================

    struct GRBEvent grbEv;
    struct EVENT Ev;
    
    int long Last_Event_Position=0;
    int long Event_Lenght=(16+320*_nScalers);
    int Offset=8;

  
    while(keep_going){
      
      sprintf(kntb,"     %d",_kount); 
      kountbuffer->LoadBuffer(kntb);

      int ctb1=0; 
      int ctb2=1;
      int ctb3=2;
      int ctb4=3;

      int wait = 0;

      // ====================== Data Block Check =====================

      
      fseek (fdata, 0 , SEEK_END); 

      while ((ftell(fdata)<Last_Event_Position+Event_Lenght+Offset)){
	wait++;
	cout << " " << wait << ". Waiting for data..." << endl;
	gSystem->Sleep(SleepTime);
	if(wait>(10*SleepTime))break;
	if(getc(fdata)==EOF)break;
	fseek (fdata, 0 , SEEK_END);
      };

      if(feof(fdata)) {
	cout << "End Of File" << endl;
	keep_going=false;
	};

      fseek (fdata, Offset+_kount*(Event_Lenght), SEEK_SET); 
      Last_Event_Position=Event_Lenght*_kount+Offset;


      // ====================== EventNo ==============================

      iread = fread(&grbEv.EventNo, sizeof(int), 1, fdata);
    
    
      //  ======================= Date ===============================


      iread = fread(&grbEv.data[0], sizeof(short), 6, fdata);

      int Y  = (swap16(grbEv.data[5]) & 0xFF00)>>8;
      int mx = swap16(grbEv.data[5]) & 0x001F;
      int M  = (mx&0xF) + (mx>>4)*10;
      int w;
      w = (swap16(grbEv.data[4]) & 0x3F00)>>8; int D   =  w%16 + w/16*10;
      w = (swap16(grbEv.data[4]) & 0x003F);    int h   =  w%16 + w/16*10;
      w = (swap16(grbEv.data[3]) & 0x7F00)>>8; int m   =  w%16 + w/16*10;
      w = (swap16(grbEv.data[3]) & 0x007F);    double sc = (double)(w%16 
								    + w/16*10);
      w = (swap16(grbEv.data[2]) & 0x0F00)>>8; sc += (double) (w%16 
							       + w/16*10)/10;
      w = (swap16(grbEv.data[2]) & 0x00FF);    sc += (double) (w%16 
							       + w/16*10)/1000;
      w = (swap16(grbEv.data[1]) & 0xF000)>>12; sc += (double) (w)/1E4;
      w = (swap16(grbEv.data[1]) & 0x0F00)>>8;  sc += (double) (w)/1E5;
      w = (swap16(grbEv.data[1]) & 0x00F0)>>4;  sc += (double) (w)/1E6;
      w = (swap16(grbEv.data[1]) & 0x000F);     sc += (double) (w)/1E7;

  
      Ev.J = G2J(2000+Y,M,D,h,m,sc);

      
      if(_kount==0) T0 = Ev.J;

      
      if(_kount%120 == 0) {
	if(_kount!=0){
	  Jint[_kount/120-1] = J_inf + (J_sup - J_inf)/2;
	  J_inf = Ev.J;
	}else{ J_inf = Ev.J;};
      };
      J_sup = Ev.J;



      //  ====================== Scaler ==============================


      iread = fread(&grbEv.r, sizeof(int), 80*_nScalers, fdata);
      
      for (int i=0;i<_nScalers;i++) {
	for (int k=0;k<80;k++) Ev.dat[k+i*80] = (unsigned int) swap32(grbEv.r[i][k]);
      };

      int mave = (_kount/120);
      int mfill = ((120-1) + (mave*120));
      int mfile = (mave+(kfile*59));

      if(_kount==0){
	sprintf(ref,"%s/Reference.txt",HMDIR.c_str());
	cout << "Reading existing " << ref << " File..." << endl;
	inave.open(ref, ios::in);
	int aper = inave.is_open();
	cout << "apertura = " << aper << endl;
	if(!inave.is_open()) {
	  sprintf(ref,"%s/Reference.txt",HMDIR.c_str());
	  cout << ref << " File doesn't exist..." << endl;
	  inave.close();
	}
      }

      if((_kount%(mfill)==0)&&(mave==58)){
	sprintf(ref,"%s/Reference.txt",HMDIR.c_str());
	cout << "Opening " << ref << " File..." << endl;
	outave.open(ref,  ios::out);
      }
	
      for (int j=0;j<NClusAcq;j++){
	
	scal1[mave][j] = scal1[mave][j] + Ev.dat[ctb1];
	scal2[mave][j] = scal2[mave][j] + Ev.dat[ctb2];
	scal3[mave][j] = scal3[mave][j] + Ev.dat[ctb3];
	scal4[mave][j] = scal4[mave][j] + Ev.dat[ctb4];

	avscal1[mave][j] = scal1[mave][j] / 120;
	avscal2[mave][j] = scal2[mave][j] / 120;
	avscal3[mave][j] = scal3[mave][j] / 120;
	avscal4[mave][j] = scal4[mave][j] / 120;

	if((_kount==0)&&(inave.is_open())) {
	  inave >> refscal1[j];
	  cout << "refscal1[" << Clus[j] << "] = " << refscal1[j] << endl;
	  scal1_inf[j] = refscal1[j] - 0.03*refscal1[j];
	  scal1_sup[j] = refscal1[j] + 0.03*refscal1[j];
	  scal1_infmed[j] = scal1_inf[j] - 0.01*scal1_inf[j];
	  scal1_supmed[j] = scal1_sup[j] + 0.01*scal1_sup[j];
	};
	

	if(avscal1[mave][j]>50000) avscal1[mave][j]=50000; 

	if((_kount%(mfill)==0)&&(_kount!=0)){ // at the end of one minute bin 


	  // average values in 1 minute arranged in a vector for the 24 hours
	  DYSCAL1[mfile][j] = avscal1[mave][j];

	  THAV1[j]->Fill((float)mfile,(float)DYSCAL1[mfile][j]);
	  th1[j]->Fill((float)_kount,(float)avscal1[mave][j]);
	  th2[j]->Fill((float)_kount,(float)avscal2[mave][j]);
	  th3[j]->Fill((float)_kount,(float)avscal3[mave][j]);
	  th4[j]->Fill((float)_kount,(float)avscal4[mave][j]);

	  // comparison with the reference values in HMDIR/Reference.txt file
	  if(refscal1[j]!=0){
	    if((avscal1[mave][j]>scal1_inf[j] && avscal1[mave][j]<scal1_sup[j])&&(Clus[j]<239)){
	      int k = Clus[j];
	      ULong_t green3;
	      gClient->GetColorByName("green3",green3);
	      fButtonclu[k]->ChangeBackground(green3);
	      fButtonclu[k]->SetState(kButtonUp);
	      fButtonclu[k]->Connect("Clicked()","ArgoFrame",this,"Zoom()");
	      gClient->NeedRedraw(fButtonclu[k]);
	    }else if((avscal1[mave][j]>=scal1_infmed[j] && avscal1[mave][j]<=scal1_inf[j] ||
		      avscal1[mave][j]>=scal1_sup[j] && avscal1[mave][j]<=scal1_supmed[j])&&(Clus[j]<239)){
	      int k = Clus[j];
	      ULong_t yellow1;
	      gClient->GetColorByName("yellow1",yellow1);
	      fButtonclu[k]->ChangeBackground(yellow1);
	      fButtonclu[k]->SetState(kButtonUp);
	      fButtonclu[k]->Connect("Clicked()","ArgoFrame",this,"Zoom()");
	      gClient->NeedRedraw(fButtonclu[k]);
	    }else if((avscal1[mave][j]<scal1_infmed[j] || avscal1[mave][j]>scal1_supmed[j])&&(Clus[j]<239)){
	      mred[j]++;
	      int k = Clus[j];
	      ULong_t red2;
	      gClient->GetColorByName("red2",red2);
	      fButtonclu[k]->ChangeBackground(red2);
	      fButtonclu[k]->SetState(kButtonUp);
	      fButtonclu[k]->Connect("Clicked()","ArgoFrame",this,"Zoom()");
	      gClient->NeedRedraw(fButtonclu[k]);
	    };
	  }else{
	  if((avscal1[mave][j]>15000 && avscal1[mave][j]<25000)&&(Clus[j]<239)){
	    int k = Clus[j];
	    ULong_t green3;
	    gClient->GetColorByName("green3",green3);
	    fButtonclu[k]->ChangeBackground(green3);
	    fButtonclu[k]->Connect("Clicked()","ArgoFrame",this,"Zoom()");
	    gClient->NeedRedraw(fButtonclu[k]);
	  }else if((avscal1[mave][j]>=10000 && avscal1[mave][j]<=15000 ||
		    avscal1[mave][j]>=25000 && avscal1[mave][j]<=30000)&&(Clus[j]<239)){
	    int k = Clus[j];
	    ULong_t yellow1;
	    gClient->GetColorByName("yellow1",yellow1);
	    fButtonclu[k]->ChangeBackground(yellow1);
	    fButtonclu[k]->Connect("Clicked()","ArgoFrame",this,"Zoom()");
	    gClient->NeedRedraw(fButtonclu[k]);
	  }else if((avscal1[mave][j]<10000 || avscal1[mave][j]>30000)&&(Clus[j]<239)){
	    mred[j]++;
	    int k = Clus[j];
	    ULong_t red2;
	    gClient->GetColorByName("red2",red2);
	    fButtonclu[k]->ChangeBackground(red2);
	    fButtonclu[k]->Connect("Clicked()","ArgoFrame",this,"Zoom()");
	    gClient->NeedRedraw(fButtonclu[k]);
	  };
	  }

 	  if(mred[j]==0){
	    if(mave!=0){HRSCAL1[mave][j] = HRSCAL1[mave-1][j] + avscal1[mave][j];
	    }else{HRSCAL1[mave][j] = HRSCAL1[mave][j] + avscal1[mave][j];}
	  }
	  

	  if(mave==58){ // at the end of the next-to-last bin

	    // ==============  Average on 1 hour and saving in HMDIR/Reference.txt  ===============

	    if(mred[j]==0){
	      HRSCAL1[mave][j] = HRSCAL1[mave][j]/(mave+1);
	    }else{
	      HRSCAL1[mave][j] = refscal1[j];
	    }
	    outave << HRSCAL1[mave][j] << endl;
	    cout << "RefWrited[" << mave << "][" << Clus[j] << "] = " << HRSCAL1[mave][j] << endl;


	    // ==================  Rotation vector arranged on 24 hours   ===================

	    if(kfile==23){ // ultimo file di 24 ore
	      for(int i=0;i<mfile-59;i++) DYSCAL1[i][j] = DYSCAL1[i+59][j];
	      for(int s=mfile-59;s<mfile+1;s++) for(int t=0; t<NClusAcq; t++) DYSCAL1[s][t] = 0;
	    }
	  }
	}; 

	ctb1+=4; 
	ctb2+=4;
	ctb3+=4;
	ctb4+=4;
      };
      
      if((_kount==0)&&(inave.is_open())){
	sprintf(ref,"%s/Reference.txt",HMDIR.c_str());
	cout << "Closing existing " << ref << " File..." << endl;
	inave.close();};
      if((_kount%(mfill)==0)&&(mave==58)){
	sprintf(ref,"%s/Reference.txt",HMDIR.c_str());
	cout << "Closing " << ref << " File..." << endl;
	outave.close();
      }
      _kount++;

      //if((Ev.J - T0)>= (1./1440.)){
      	if((Ev.J - T0)>= (1./1440.)&&(OPF==0)){
	  //if((Ev.J - T0)>= (1./720.)&&(OPF==0)){
      	DoDraw();
      	T0 = Ev.J;
	};
	//};
    }; // events
  };
  return;
  };


// ============================= Draw ==========================

void ArgoFrame::DoDraw() {

  for(int i = 0; i<NClusAcq; i++) {
    for(int g = 0; g<NClusAcq; g++) {
      if(Clus[i] == Clus_g[g]) { 
	jc[g] = i; 
      };
    };
  };

  //if(fActiveHistos!=0)delete fActiveHistos;
  fActiveHistos = new TList();
  flist->GetSelectedEntries(fActiveHistos);
  //if(hID!=0)delete hID;
  hID = new TObject();    
  k=0;
  int NScaler = 0;
  static int _memscal;
  static int _memsch;
  
  while(fActiveHistos->At(k)!=0){ 
    hID = fActiveHistos->At(k);
    fListID[k] = ((TGLBEntry*)hID)->EntryId();
    NScaler = fListID[k];
    // changing scaler
    if(NScaler!=_memscal){for(int s=0;s<10;s++) for(int t=0;t<4;t++) idraw[s][t]=0;}
    _memscal = NScaler;
    k++;
    };

  // changing page
  if(sch!=_memsch){for(int s=0;s<10;s++) for(int t=0;t<4;t++) idraw[s][t]=0;}	
  _memsch = sch; 

  Kount_inf = -10.;
  for (int j=0;j<nclupag;j++){

    // controllare meglio il Kount_sup nel caso il rescal1 sia 0
    if(NScaler==0){
      if(refscal1[jc[(nclupag*sch)+j]]!=0){
	Kount_sup = (refscal1[jc[(nclupag*sch)+j]]+(0.5*(2*NScaler+2)*refscal1[jc[(nclupag*sch)+j]]));
      }else{
	Kount_sup = (average[NScaler]+(0.5*(2*NScaler+2)*average[NScaler]));
      }
    }else{
      Kount_sup = (average[NScaler]+(0.5*(2*NScaler+2)*average[NScaler]));
    }

    fC1->cd(j+1);

    if(idraw[sch][NScaler]==0){
      gStyle->SetOptStat(0000000);
      gStyle->SetOptTitle(0);
      if(NScaler==0){
	th1[jc[(nclupag*sch)+j]]->GetXaxis()->SetTitle("Event");
	th1[jc[(nclupag*sch)+j]]->GetXaxis()->SetNdivisions(405);
	th1[jc[(nclupag*sch)+j]]->GetXaxis()->SetLabelSize(0.055);
	th1[jc[(nclupag*sch)+j]]->GetYaxis()->SetLabelSize(0.055);
	th1[jc[(nclupag*sch)+j]]->SetMaximum(Kount_sup);
	th1[jc[(nclupag*sch)+j]]->SetMinimum(Kount_inf);
	th1[jc[(nclupag*sch)+j]]->SetLineColor(2);
	th1[jc[(nclupag*sch)+j]]->SetLineWidth(2);
	th1[jc[(nclupag*sch)+j]]->SetMarkerStyle(21);
	th1[jc[(nclupag*sch)+j]]->SetMarkerColor(2);
	th1[jc[(nclupag*sch)+j]]->SetMarkerSize(0.3);
	th1[jc[(nclupag*sch)+j]]->Draw("P0");
      }else if(NScaler==1){
	th2[jc[(nclupag*sch)+j]]->GetXaxis()->SetTitle("Event");
	th2[jc[(nclupag*sch)+j]]->GetXaxis()->SetNdivisions(405);
	th2[jc[(nclupag*sch)+j]]->GetXaxis()->SetLabelSize(0.055);
	th2[jc[(nclupag*sch)+j]]->GetYaxis()->SetLabelSize(0.055);
	th2[jc[(nclupag*sch)+j]]->SetMaximum(Kount_sup);
	th2[jc[(nclupag*sch)+j]]->SetMinimum(Kount_inf);
	th2[jc[(nclupag*sch)+j]]->SetLineColor(2);
	th2[jc[(nclupag*sch)+j]]->SetLineWidth(2);
	th2[jc[(nclupag*sch)+j]]->SetMarkerStyle(21);
	th2[jc[(nclupag*sch)+j]]->SetMarkerColor(2);
	th2[jc[(nclupag*sch)+j]]->SetMarkerSize(0.3);
	th2[jc[(nclupag*sch)+j]]->Draw("P0");
      }else if(NScaler==2){
	th3[jc[(nclupag*sch)+j]]->GetXaxis()->SetTitle("Event");
	th3[jc[(nclupag*sch)+j]]->GetXaxis()->SetNdivisions(405);
	th3[jc[(nclupag*sch)+j]]->GetXaxis()->SetLabelSize(0.055);
	th3[jc[(nclupag*sch)+j]]->GetYaxis()->SetLabelSize(0.055);
	th3[jc[(nclupag*sch)+j]]->SetMaximum(Kount_sup);
	th3[jc[(nclupag*sch)+j]]->SetMinimum(Kount_inf);
	th3[jc[(nclupag*sch)+j]]->SetLineColor(2);
	th3[jc[(nclupag*sch)+j]]->SetLineWidth(2);
	th3[jc[(nclupag*sch)+j]]->SetMarkerStyle(21);
	th3[jc[(nclupag*sch)+j]]->SetMarkerColor(2);
	th3[jc[(nclupag*sch)+j]]->SetMarkerSize(0.3);
	th3[jc[(nclupag*sch)+j]]->Draw("P0");
      }else if(NScaler==3){
	th4[jc[(nclupag*sch)+j]]->GetXaxis()->SetTitle("Event");
	th4[jc[(nclupag*sch)+j]]->GetXaxis()->SetNdivisions(405);
	th4[jc[(nclupag*sch)+j]]->GetXaxis()->SetLabelSize(0.055);
	th4[jc[(nclupag*sch)+j]]->GetYaxis()->SetLabelSize(0.055);
	th4[jc[(nclupag*sch)+j]]->SetMaximum(Kount_sup);
	th4[jc[(nclupag*sch)+j]]->SetMinimum(Kount_inf);
	th4[jc[(nclupag*sch)+j]]->SetLineColor(2);
	th4[jc[(nclupag*sch)+j]]->SetLineWidth(2);
	th4[jc[(nclupag*sch)+j]]->SetMarkerStyle(21);
	th4[jc[(nclupag*sch)+j]]->SetMarkerColor(2);
	th4[jc[(nclupag*sch)+j]]->SetMarkerSize(0.3);
	th4[jc[(nclupag*sch)+j]]->Draw("P0");
      }
    };    

    sprintf(titth,"%03d",Clus_g[(nclupag*sch)+j]);
    delete tl1[j];
    tl1[j] = new TPaveText(0.416725,0.865069,0.605189,0.961514,"blNDC");
    tl1[j]->SetBorderSize(2);
    tl1[j]->AddText(titth);
    tl1[j]->Draw();
    
    if(Clus_g[(nclupag*sch)+j] < 239){
      delete ln[j];
      if(NScaler==0){
      ln[j] = new TLine(kount_inf,refscal1[jc[(nclupag*sch)+j]],kount_sup,refscal1[jc[(nclupag*sch)+j]]);
      }else{
      ln[j] = new TLine(kount_inf,average[NScaler],kount_sup,average[NScaler]);
      }
      ln[j]->SetLineStyle(1);
      ln[j]->SetLineWidth(1);
      ln[j]->SetLineColor(9);
      ln[j]->Draw("");
    }else{
      delete pt1[j];
      pt1[j] = new TPaveText(0.36413,0.453066,0.662167,0.664268,"blNDC");
      pt1[j]->SetBorderSize(2);
      pt1[j]->SetFillColor(38);
      pt1[j]->AddText("OFF");
      pt1[j]->Draw();
      };
  };
  idraw[sch][NScaler]=1;
    
  fC1->Modified();
  fC1->Update();
  gSystem->ProcessEvents();
};




void ArgoFrame::DoDraw(int jclu) {
  

  for(int j = 0; j<NClusAcq; j++) {
    if(Clus[j]==jclu)  jpos = j; 
  }
 
  int NScaler = 0;

  Kount_inf = -10.;
  Kount_sup = (refscal1[jpos]+ 15000);
      
  gStyle->SetOptStat(0000000);
  gStyle->SetOptFit(0000);

  sprintf(namth,"htm_%03d",jclu);
  sprintf(titth,"Cluster %03d",jclu);

  sprintf(nam1,"AveScaler%dvsTime_%03d",NScaler+1,jclu);
  sprintf(tit1,"Cluster = %d",jclu);
  ths = (TH1F*)gDirectory->FindObject(nam1);
  if(ths==NULL)cout << "NULL pointer" << endl;

  fCN->cd(1);
  ths->SetTitle(tit1);
  ths->SetMarkerStyle(21);
  ths->SetMarkerStyle(2);
  ths->SetMarkerColor(2);
  ths->SetMarkerSize(1);
  ths->GetXaxis()->SetTitle("Minutes");
  ths->GetYaxis()->SetTitle("Scaler >=1");
  ths->GetYaxis()->SetTitleOffset(1.2);
  ths->GetXaxis()->SetNdivisions(319);
  ths->SetMinimum(Kount_inf);
  ths->SetMaximum(Kount_sup);
  ths->SetLineColor(2);
  ths->SetLineWidth(1);
  ths->Draw("P0");

  delete tln;
  tln = new TLine(0,refscal1[jpos],24*59,refscal1[jpos]);
  tln->SetLineWidth(1);
  tln->SetLineColor(9);
  tln->Draw("");

  fCN->Modified();
  fCN->Update();
};


void ArgoFrame::Forward() {
  sch++;
  if(sch>=npag) sch=0;
  DoDraw();
};

void ArgoFrame::Backward() {
  sch--;
  if(sch==-1) sch=(npag-1);
  DoDraw();
};


void ArgoFrame::Zoom() {

  TThread::Lock();  
  TGButton *btn = (TGButton *)gTQSender;
  BID = btn->WidgetId();
  cout << "Button ID = " << BID << endl;
 
  WinFrame(gClient->GetRoot(),200,200);
  DoDraw(BID);

};


void ArgoFrame::CloseMainFrame() {
  TThread::Lock();
  gApplication->Terminate(0);
}

void ArgoFrame::CloseWin() {
  TTimer::SingleShot(150, "ArgoFrame", this, "CloseWindowCluster()");
  TThread::UnLock();
};

void ArgoFrame::CloseWindowCluster() {
  fMainWin->SendCloseMessage();
  delete win;
  delete hwinframe;
  delete fEcanWin;
  delete fMainWin;
}

void ArgoFrame::Loop() {

  ifstream infile("argomain.ini");
  infile >> DIR;
  infile >> HMDIR;
  infile >> fom; 
  infile >> _nScalers;
  infile >> yr;
  infile >> mth;
  infile >> dy;
  infile >> hr;

  // -------------------> Initializing thread
  gDebug = kTRUE;
  mThreadrun = kTRUE;

  if( fom!=0 ) {
    // -------------------> program operates in automatic mode 
    //                      (changes file with the computer clock)
    sprintf(ThName,"Thr1");
    fTh1 = new TThread(ThName,(void(*) (void*))&Thread1,(void*)this);
    fTh1->Run();
    while(1) {
      gSystem->ProcessEvents();
      gSystem->Sleep(100);
    };
  };
};
















//  ===========================   Store    ==============================



//         if(MT != _min){
//           _kount =0;
//           OPF = 1;
//            keep_going = true;
//           _min=MT;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) scal1[s][t]=0;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) scal2[s][t]=0;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) scal3[s][t]=0;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) scal4[s][t]=0;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) avscal1[s][t]=0;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) avscal2[s][t]=0;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) avscal3[s][t]=0;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) avscal4[s][t]=0;
//           for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) HRSCAL1[s][t]=0;
//           //for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) HRSCAL2[s][t]=0;
//           //for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) HRSCAL3[s][t]=0;
//           //for(int s=0;s<59;s++) for(int t=0; t<NClusAcq; t++) HRSCAL4[s][t]=0;
//           for(int t=0; t<NClusAcq; t++) refscal1[t]=0;
//           for(int t=0; t<NClusAcq; t++) scal1_inf[t]=0;
//           for(int t=0; t<NClusAcq; t++) scal1_sup[t]=0;
//           for(int t=0; t<NClusAcq; t++) mred[t]=0;
//           for(int s=0;s<59;s++) Jint[s]=0;

//           if(fdata==NULL){
// 	    Histo(0); 

// 	    sprintf(flnm1,"             grb%02d%02d%02d.%02d",(YER-2000),MON,DY,_min);
// 	    filebuffer->LoadBuffer(flnm1);

// 	    sprintf(dayy,"%s/grb%02d%02d%02d.%02d",DIR.c_str(),(YER-2000),MON,DY,_min);
// 	    sprintf(rawfile,"%s",dayy);

// 	    fdata = fopen(rawfile,"r");
// 	    cout << "kfile = " << kfile << endl;
// 	    cout << "Open file : " << rawfile << endl;
// 	    if(fdata == NULL) {printf("File : %s not found\n",rawfile); return;};
// 	    OPF = 0;
//           }else{

// 	    // devo simulare il cambio del giorno (TOGLIERE PER TIBET)
// 	    if(kfile>=23){
// 	      if(kfile==23){
// 		cout << "sono qui" << endl;
// 		DY++;
// 		kfile=0;
// 	      }
// 	      _min = _min-24;
	  
// 	    }

// 	    int chiusura = fclose(fdata);  
// 	    cout << "fclose = " << chiusura << endl;
// 	    Histo(1);
// 	    sprintf(dayy,"%s/grb%02d%02d%02d.%02d",DIR.c_str(),(YER-2000),MON,DY,_min);
// 	    sprintf(rawfile,"%s",dayy);
// 	    fdata = fopen(rawfile,"r");
// 	    kfile++;
// 	    cout << "kfile = " << kfile << endl;
// 	    cout << "Open file : " << rawfile << endl;
// 	    if(fdata == NULL) {printf("File : %s not found\n",rawfile); return;};
// 	    OPF = 0;

// 	    sprintf(flnm2,"             grb%02d%02d%02d.%02d",(YER-2000),MON,DY,_min);
// 	    filebuffer->LoadBuffer(flnm2);
//           };
//         }else{goto skip_point;};


//   exit = new TGTextButton(hframe,"&Exit","gApplication->Terminate(0)");
//   hframe->AddFrame(exit, new TGLayoutHints(kLHintsCenterX,5,5,2,1));


//       kountbuffer->Clear();
//       sprintf(kntb,"    %0d",_kount);
//       kountname->SetFont("-adobe-helvetica-medium-r-*-*-14-*-*-*-*-*-iso8859-1");
//       kountbuffer->AddText(0,kntb,10);
//       kountname->WantFocus();


//         	sprintf(flnm1,"         grb%02d%02d%02d.%02d",(YER-2000),MON,DY,_hour);
//         	filename->SetFont("-adobe-helvetica-bold-r-*-*-14-*-*-*-*-*-iso8859-1");
//         	filebuffer->AddText(0,flnm1,30);


//         	filebuffer->Clear();
//         	sprintf(flnm2,"         grb%02d%02d%02d.%02d",(YER-2000),MON,DY,_hour);
//         	filename->SetFont("-adobe-helvetica-bold-r-*-*-14-*-*-*-*-*-iso8859-1");
//         	filebuffer->AddText(0,flnm2,30);


















